package de.lmu.ifi.medien.mmi2.labyrinth;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Point;
import android.graphics.Paint.Align;
import android.graphics.Paint.Cap;
import android.os.Vibrator;
import android.view.MotionEvent;
import android.view.View;



public class LabyrinthView extends View {

	private final static int LABYRINTH_SCALE_FACTOR = 43; // for 480x800 pixel screen, change as required

	public int fingerOffset = 100;

	private Vector<Line> lines = null;

	private Vibrator vibrator = null;
	
	// add more member variables as needed
	// ...

	public LabyrinthView(Context c, Vector<Line> ls) {
		super(c);
		lines = ls;
		
		// Initialisieren von android.graphics.Paint Objekten
		// setARGB, setStrokeWidth, setStrokeCap, setTextSize, ...
		// ...
		
		// Skalieren der Labyrinth-Linien auf Display-Gre
		// Verwendung von LABYRINTH_SCALE_FACTOR
		// ...

		// Feedback, falls Wnde berhrt werden (nur Gert, kein Effekt im Emulator)
		vibrator = (Vibrator) c.getSystemService(Context.VIBRATOR_SERVICE);
		// vibrate...

	}

	protected void onSizeChanged(int w, int h, int oldw, int oldh) {
		// scale labyrinth to fill screen
		// entweder statisch im Konstruktur (siehe oben) oder dynamisch hier
		// ...
	}

	protected void onDraw(Canvas c) {
		
		// system erases display contents before onDraw is called
		// so have to redraw everything...

		// draw labyrinth
		// ...

		// draw start square (left, top)
		// ...

		// draw finish square (right, bottom)

		// draw connected touch points
		// ...
		
		// show number of collisions
		// ...
		
		// show "Finished" or similar, if successful move through labyrinth
		//...

	}

	public boolean onTouchEvent(MotionEvent e) {

		// get touch position
		
		// enter into list of touch points
		
		// initialization of new stroke for MotionEvent.ACTION_DOWN
		
		// check if started in start area
		
		// check if ended in stop area without lifting off

		// count the number of collisions (consider current and previous touch point)
		int newCollisions = countCollisions();

		// vibrate if there are collisions

		// update the screen
		invalidate();

		return true;
	} 

	private int countCollisions() {
		// for each labyrinth line, show whether line from previous to current touch point crosses labyrinth line
		// ...
		
		// simple checks first (e.g. both touch points to the left of considered labyrinth line)
		
		// for those passing simple test:
		// compute intersection point between labyrinth line and touch line
		// check whether intersection point is on labyrinth line segment
		// if so, increase number of collisions.
		
		return 0; // return number of collisions
	}

}